$(document).ready(function() {
	
	$( ".tabs" ).tabs();

	$('html').droppable( {
		greedy: true,
		accept: '#game-01 table span',
		drop: function(event, ui) {
			ui.draggable.closest('.game').children('span').each(function(index, value) {
				if (ui.draggable[0].innerText == value.innerText) {
					$(this).removeClass('dragged correct incorrect');
				}	
			});
			ui.draggable.remove();
		}
	});	

	/**
	 *  === GENERAL - ORDER GAME ===
	 */

	var gameOrderInitialState = new Object();
	$('.game-order').each(function() {
		gameOrderInitialState[$(this).attr("id")] = $(this).clone();
	});

	function gameOrderAddListeners() {
		$('.game-order .draggable').draggable({
			revert: 'invalid'
		});

		$('.game-order .droppable').droppable( {
			hoverClass: 'hover',
			drop: function(event, ui) {
				toBeMoved = $(this).children('span').detach();
				ui.draggable.parent().append(toBeMoved);
				$(this).append(ui.draggable.css('top', '').css('left', ''));
			}
		});

		$('.game-order .check').off('click').on('click', function() {
			$(this).closest('.game').find('.droppable').each(function() {
				if ( $(this).data('solution') == $(this).children('span').html() ) {
					$(this).removeClass('incorrect').addClass('correct');
				}
				else {
					$(this).removeClass('correct').addClass('incorrect');
				}
			});
		});

		$('.game-order .reset').off('click').on('click', function() {
			var thisGame = $(this).closest('.game');
			for (var gameOrder in gameOrderInitialState) {
				if ( gameOrder == thisGame.attr("id") ) {
					thisGame.replaceWith(gameOrderInitialState[gameOrder].clone());
					break;
				}
			}
			gameOrderAddListeners();
		});
	}

	gameOrderAddListeners();

	/**
	 * === SELECT POPUP - SELECTION ===
	 */

	$('#game-01 select').html('<option></option><option>is</option><option>are</option><option>am</option>');
	$('#game-10 select').html('<option></option><option>Yes, it is.</option><option>No, it isn\'t.</option>');
	$('#game-12 select, #game-13 select, #game-14 select').html('<option></option><option>Yes, I have.</option><option>No, I haven\'t.</option>');
	$('#game-15 select').html('<option></option><option>Yes</option><option>No</option>');
	$('#game-16 select').html('<option></option><option>Yes, I can.</option><option>No, I can\'t.</option>');


	/**
	 *  === GENERAL - BASKET GAME ===
	 */

	$('.game-basket > span').draggable({
		revert: "invalid",
		helper: 'clone'
	});

	$('.game-basket .basket').droppable( {
		greedy: true,
		hoverClass: 'hover',
		drop: function(event, ui) {
			if ( ui.draggable.parent().hasClass('game') ) {
				// slovo přetáhnuto z výběru nahoře
				if ( !ui.draggable.hasClass('dragged') ) {
					character = ui.draggable.clone().draggable({
						helper: 'clone'
					});
					$(this).find('p').append(character);
					ui.draggable.addClass('dragged');
				}
			}
			else {
				// slovo přetáhnuto z vedlejší kolonky
				character = ui.draggable.clone().draggable({
					helper: 'clone'
				});
				$(this).find('p').append(character);
				ui.draggable.remove();
			}
			return false;
		}
	});

	$('.game-basket .check').on('click', function() {
		var parent = $(this).closest('.game');
		var allChars = parent.children('span');
		for (var i = 1; i <= parent.data('amount'); i++) {
			parent.find('.basket-' + i + ' span').each(function() {
				var character = $(this).html();
				if ( $(this).data('type') == i ) {
					$(this).removeClass('incorrect').addClass('correct');
					allChars.each(function() {
						if ($(this).html() == character) {
							$(this).removeClass('dragged incorrect').addClass('correct');
						}
					});
				}
				else {
					$(this).removeClass('correct').addClass('incorrect');
					allChars.each(function() {
						if ($(this).html() == character) {
							$(this).removeClass('dragged correct').addClass('incorrect');
						}
					});
				}
			});
		}
	});

	$('.game-basket .reset').on('click', function() {
		var parent = $(this).closest('.game');
		parent.find('.basket span').remove();	
		parent.children('span').removeClass('dragged correct incorrect');
	});

	/**
	 * === GENERAL - WORD TO MULTIPLE CELLS ===
	 */

	$('.word-to-multiple-cells .droppable').droppable( {
		greedy: true,
		hoverClass: 'hover',
		drop: function(event, ui) {
			if ( !ui.draggable.parent().hasClass('game') ) {
				// slovo přetáhnuto z vedlejší kolonky
				character = ui.draggable.clone().draggable({
					helper: 'clone'
				});
				character.removeClass('correct incorrect');
				$(this).html(character);
				ui.draggable.remove();
			}
			else {
				// slovo přetáhnuto z věty nahoře
				character = ui.draggable.clone().draggable({
					helper: 'clone'
				});
				$(this).html(character);
			}
			return false;
		}
	});

	$('.word-to-multiple-cells .check').on('click', function() {
		$(this).closest('.game').find('p span').each(function() {
			var innerSpan = $(this).children('span');
			if ( $(this).data('correct') == innerSpan.html() ) {
				innerSpan.removeClass('incorrect').addClass('correct');
			}
			else {
				innerSpan.removeClass('correct').addClass('incorrect');
			}
		});

	});


	/**
	 * === GENERAL - WORD TO CELL and WORD TO MULTIPLE CELLS ===
	 */

	$('.single-word-to-cell > span, .word-to-multiple-cells > span').draggable({
		revert: "invalid",
		helper: 'clone'
	});

	$('.single-word-to-cell .droppable').droppable( {
		greedy: true,
		hoverClass: 'hover',
		drop: function(event, ui) {
			if ( !ui.draggable.parent().hasClass('game') ) {
				// slovo přetáhnuto z vedlejší kolonky
				character = ui.draggable.clone().draggable({
					helper: 'clone'
				});
				character.removeClass('correct incorrect');
				$(this).html(character);
				ui.draggable.remove();
			}
			else {
				// slovo přetáhnuto z věty nahoře
				if ( !ui.draggable.hasClass('dragged') ) {
					character = ui.draggable.clone().draggable({
						helper: 'clone'
					});
					$(this).html(character);
					ui.draggable.addClass('dragged');
				}
			}
			return false;
		}
	});

	$('.single-word-to-cell .check').on('click', function() {
		$(this).closest('.game').find('p span').each(function() {
			var innerSpan = $(this).children('span');
			if ( $(this).data('solution') == innerSpan.html() ) {
				innerSpan.removeClass('incorrect').addClass('correct');
				$(this).closest('.game').children('span').each(function() {
					if ( $(this).html() == innerSpan.html() ) {
						$(this).removeClass('dragged incorrect').addClass('correct');
					}
				});
			}
			else {
				innerSpan.removeClass('correct').addClass('incorrect');
				$(this).closest('.game').children('span').each(function() {
					if ( $(this).html() == innerSpan.html() ) {
						$(this).removeClass('dragged correct').addClass('incorrect');
					}
				});
			}
		});

	});

	$('.single-word-to-cell .reset, .word-to-multiple-cells .reset').on('click', function() {
		$(this).closest('.game').find('.droppable span').remove();
		$(this).closest('.game').children('span').removeClass('dragged incorrect correct');
	});


	/**
	 * === GENERAL - CLICK TO SELECT ===
	 */

	$('.click-select .words span').on('click', function() {
		if ( $(this).hasClass('selected') ) {
			$(this).removeClass('selected');
	}
	else {
			$(this).removeClass('correct incorrect').addClass('selected');
	}
	});

	$('.click-select .check').on('click', function() {
		$(this).closest('.click-select').find('.words span').each(function() {
			if ( ($(this).data('correct') && $(this).hasClass('selected')) ||
					 (!$(this).data('correct') && !$(this).hasClass('selected')) ) {
				$(this).removeClass('selected').addClass('correct');
			}
			else {
				$(this).removeClass('selected').addClass('incorrect');
			}
		});

	});

	$('.click-select .reset').on('click', function() {
		$(this).closest('.click-select').find('.words span').removeClass('selected correct incorrect');
	});


	/**
	 * === GENERAL - CLICK TO SELECT - VARIANTS ===
	 */

	$('.click-select-variants .words span').on('click', function() {
		if ( $(this).hasClass('selected') ) {
			$(this).removeClass('selected');
	}
	else {
			$(this).removeClass('correct incorrect').addClass('selected');
	}
	});

	$('.click-select-variants .check').on('click', function() {
		$(this).closest('.click-select-variants').find('.words span').each(function() {
			if ( $(this).hasClass('selected') && $(this).data('correct') ) {
				$(this).removeClass('selected').addClass('correct');
			}
			else if ( $(this).hasClass('selected') && !$(this).data('correct') ) {
				$(this).removeClass('selected').addClass('incorrect');
			}
		});

	});

	$('.click-select-variants .reset').on('click', function() {
		$(this).closest('.click-select-variants').find('.words span').removeClass('selected correct incorrect');
	});

	/**
	 * === GENERAL - SELECT POPUP ===
	 */

	// zkontroluje správnost
	$('.game-select .check').on('click', function() {
		$(this).closest('.game-select').find('select').each(function(index) {			
			if ( $(this).val() == $(this).data('solution') ) {
				$(this).addClass('correct');
			}
			else {
				$(this).addClass('incorrect');
			}
		});
	});
	
	// vyresetuje barvy při jakékoliv změně selectu
	$('.game-select select').on('change', function() {
		$(this).removeClass('correct incorrect');
	});
	
	// vyresetuje hru
	$('.game-select .reset').on('click', function() {
		$(this).closest('.game-select').find('select').each(function() {
			$(this).removeClass('correct incorrect').val('');
		});
		$(this).closest('.game-select').find('.puzzle img:not(:first-child)').hide();
	});

	/**
	 * === GENERAL - INPUT TEXT ===
	 */

	$('.input-text .check').on('click', function() {
		$(this).closest('.game').find('input').each(function() {	
			if ( $(this).val() == $(this).data('solution') ) {
				$(this).addClass('correct');
			}
			else {
				$(this).addClass('incorrect');
			}
		});
	});

	$('.input-text input').on('click', function() {
		$(this).removeClass('correct incorrect');
	});

	$('.input-text .reset').on('click', function() {
		$(this).closest('.game').find('input').val('');
	});


});