var activePresentation;
var activePresentationPlayer;
var activePresentationAbsoluteSlideTimes = [];
var activePresentationActiveSlideIndex = 0;
var presentationInterval;

$(document).ready(function() {
	
	var presentations = $('.presentation');

	presentations.find('audio').audioPlayer({
		classPrefix: 'audioplayer',
		strPlay: 'Přehrát',
		strPause: 'Pozastavit',
		strVolume: 'Hlasitost'
	});
	
	presentations.find('.audioplayer-playpause').click(function() {
		// pokud bezi jiny player, nez na ktery jsem klikl, zastavim ho
		if(activePresentation && activePresentation != getPresentation(this)) {
			getPresentationPlayer(activePresentation).pause();
		}
		
		if(!activePresentation || activePresentation != getPresentation(this)) {
			setActivePresentation(this);
		}
		
		if(activePresentationPlayer.paused) {
			window.clearInterval(presentationInterval);
			presentationInterval = null;
		} else if(!presentationInterval) {		
			presentationInterval = window.setInterval('checkIfShowNextSlide()', 50);
		}
	});
	
	presentations.find('.audioplayer-bar').mouseup(function() {
		var presentation = getPresentation(this);

		if(activePresentation && activePresentation == presentation) {
			activePresentationActiveSlideIndex = getPresentationActiveSlideIndex(presentation);
		}
		
		showPresentationSlide(getPresentationActiveSlide(presentation));
	});
});

function getPresentation(clickedObject) {
	return $(clickedObject).closest('.presentation').get(0);
}

function getPresentationPlayer(presentation) {
	return $(presentation).find('audio').get(0);
}

function getPresentationAbsoluteSlideTimes(presentation) {
	var temp = 0;
	presentationTimes = [];
	$(presentation).find('img').each(function(i) {
		presentationTimes[i] = temp;
		temp += $(this).data('time');
	});
	return presentationTimes;
}

function getPresentationActiveSlide(presentation) {
	return $(presentation).find('img:eq(' + getPresentationActiveSlideIndex(presentation) + ')');
}

function getPresentationActiveSlideIndex(presentation) {
	var presentationTimes = getPresentationAbsoluteSlideTimes(presentation);
	var presentationPlayer = getPresentationPlayer(presentation);
	for(var i = 0; i < presentationTimes.length; i++) {
		if(presentationTimes[i] > presentationPlayer.currentTime) {
			return i-1;
		}
	}
	return presentationTimes.length-1;
}

function setActivePresentation(clickedElement) {
	activePresentation = getPresentation(clickedElement);
	activePresentationPlayer = $(activePresentation).find('audio').get(0);
	activePresentationAbsoluteSlideTimes = getPresentationAbsoluteSlideTimes(activePresentation);
	activePresentationActiveSlideIndex = getPresentationActiveSlideIndex(activePresentation);
	showPresentationSlide(getPresentationActiveSlide(activePresentation));
}

function showPresentationSlide(slide) {
	slide.closest('.presentation').find('img').removeClass('active');
	slide.addClass('active');
}

function checkIfShowNextSlide() {
	if(activePresentationPlayer.ended) {
		activePresentation = null;
		window.clearInterval(presentationInterval);
		presentationInterval = null;
	} else if (activePresentationPlayer.currentTime >= activePresentationAbsoluteSlideTimes[activePresentationActiveSlideIndex+1]) {
		activePresentationActiveSlideIndex++;
		var nextSlide = $(activePresentation).find('.active').next();
		if(nextSlide) {
			showPresentationSlide(nextSlide);
		}
	}
}